#include <iostream>
#include "sdk/amxxmodule.h"

using namespace std;

template<class T> class Node
{
public:
	const T * info;	//some arb data - eg to contain a pointer to a class
	Node<T> *next;
	Node<T> *prev;

	Node() { prev = NULL; next = NULL; info = NULL; };
};

template <class T> class linkedListType
{
public:
	void initializeList();
	//function to initialize first element in list to zero
	//postcondition: first = NULL last = NULL

	bool isEmpty();
	//function to see if list contains elements

	int countItems();
	//function to return the number of elements initialized in the list

	T * firstItem();
	//function to return the first item in the list

	T * lastItem();
	//function to return the last item in the list

	T * nextItem();
	//function to return the next item in the list

	T * deleteItem();
	//function to delete the current item in the list

	void appendItem(const T& newItem);
	//function to append an item to the list

	linkedListType();
	//constructor

	~linkedListType();
	//destructor

protected:
	Node<T> *first;	//pointer to first node
	Node<T> *last;	//pointer to last node
	Node<T> *current;	//pointer to last node
	int count;	//stores number of items in the list
};

template<class T> bool linkedListType<T>::isEmpty()
{
	return (first == NULL);
}

template<class T> linkedListType<T>::linkedListType()
{
	first = NULL;
	last = NULL;
	count = 0;
}

template<class T> linkedListType<T>::~linkedListType()
{
	Node<T> *temp;

	while(first != NULL)
	{
		temp = first;
		first = first->next;
		delete temp;
	}
	last = NULL;
	count=0;
}

template<class T> int linkedListType<T>::countItems()
{
	return count;
}

template<class T> T * linkedListType<T>::firstItem()
{
	if(!isEmpty())
	{
		current = first;
		return (T *)current->info;
		//NB: return the first node's data member eg: return any object
	}
	else
	{
		current = NULL;
		return NULL;
	}
}

template<class T> T * linkedListType<T>::lastItem()
{
	if(!isEmpty())
	{
		current = last;
		return (T *)current->info;			
		//NB: return the first node's data member eg: return any object
	}
	else
	{
		return NULL;
	}
}

template<class T> T * linkedListType<T>::nextItem()
{
	T * ret;
	if(current->next)
	{
		ret = (T *)current->next->info;
		current = current->next;
	}
	else
	{
		ret = NULL;
	}
	return ret;
}

template<class T> void linkedListType<T>::appendItem(const T& newItem)
{
	Node<T> * newNode = new Node<T>;
	newNode->info = &newItem;
	if(!first)
	{
		first = last = newNode;
	}
	else if(last)
	{
		last->next = newNode;
		newNode->prev = last;
		last = newNode;
	}

	current = first;

	count++;
}

template<class T> T * linkedListType<T>::deleteItem()
{
	if(current)
	{
		if(current->next)
		{
			current->next->prev = current->prev;
			if(current->prev)
				current->prev->next = current->next;
			else
				first = current->next;
		}
		else if(current->prev)
		{
			current->prev->next = current->next;
			if(current->next)
				current->next->prev = current->prev;
			else
				last = current->prev;
		}
		else
		{
			first = last = NULL;
		}

		count--;
		delete current;
	}
	return firstItem();
}
